# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['RemoteIdentityArgs', 'RemoteIdentity']

@pulumi.input_type
class RemoteIdentityArgs:
    def __init__(__self__, *,
                 account_id: pulumi.Input[str],
                 remote_identity_group_id: pulumi.Input[str],
                 username: pulumi.Input[str]):
        """
        The set of arguments for constructing a RemoteIdentity resource.
        :param pulumi.Input[str] account_id: The account for this remote identity.
        :param pulumi.Input[str] remote_identity_group_id: The remote identity group.
        :param pulumi.Input[str] username: The username to be used as the remote identity for this account.
        """
        pulumi.set(__self__, "account_id", account_id)
        pulumi.set(__self__, "remote_identity_group_id", remote_identity_group_id)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Input[str]:
        """
        The account for this remote identity.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="remoteIdentityGroupId")
    def remote_identity_group_id(self) -> pulumi.Input[str]:
        """
        The remote identity group.
        """
        return pulumi.get(self, "remote_identity_group_id")

    @remote_identity_group_id.setter
    def remote_identity_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "remote_identity_group_id", value)

    @property
    @pulumi.getter
    def username(self) -> pulumi.Input[str]:
        """
        The username to be used as the remote identity for this account.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: pulumi.Input[str]):
        pulumi.set(self, "username", value)


@pulumi.input_type
class _RemoteIdentityState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[str]] = None,
                 remote_identity_group_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RemoteIdentity resources.
        :param pulumi.Input[str] account_id: The account for this remote identity.
        :param pulumi.Input[str] remote_identity_group_id: The remote identity group.
        :param pulumi.Input[str] username: The username to be used as the remote identity for this account.
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if remote_identity_group_id is not None:
            pulumi.set(__self__, "remote_identity_group_id", remote_identity_group_id)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[str]]:
        """
        The account for this remote identity.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="remoteIdentityGroupId")
    def remote_identity_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        The remote identity group.
        """
        return pulumi.get(self, "remote_identity_group_id")

    @remote_identity_group_id.setter
    def remote_identity_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remote_identity_group_id", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        The username to be used as the remote identity for this account.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)


class RemoteIdentity(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 remote_identity_group_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        RemoteIdentities define the username to be used for a specific account
         when connecting to a remote resource using that group.

        ## Import

        A RemoteIdentity can be imported using the id, e.g.,

        ```sh
         $ pulumi import sdm:index/remoteIdentity:RemoteIdentity example i-12345678
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account for this remote identity.
        :param pulumi.Input[str] remote_identity_group_id: The remote identity group.
        :param pulumi.Input[str] username: The username to be used as the remote identity for this account.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RemoteIdentityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        RemoteIdentities define the username to be used for a specific account
         when connecting to a remote resource using that group.

        ## Import

        A RemoteIdentity can be imported using the id, e.g.,

        ```sh
         $ pulumi import sdm:index/remoteIdentity:RemoteIdentity example i-12345678
        ```

        :param str resource_name: The name of the resource.
        :param RemoteIdentityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RemoteIdentityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 remote_identity_group_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RemoteIdentityArgs.__new__(RemoteIdentityArgs)

            if account_id is None and not opts.urn:
                raise TypeError("Missing required property 'account_id'")
            __props__.__dict__["account_id"] = account_id
            if remote_identity_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'remote_identity_group_id'")
            __props__.__dict__["remote_identity_group_id"] = remote_identity_group_id
            if username is None and not opts.urn:
                raise TypeError("Missing required property 'username'")
            __props__.__dict__["username"] = username
        super(RemoteIdentity, __self__).__init__(
            'sdm:index/remoteIdentity:RemoteIdentity',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[str]] = None,
            remote_identity_group_id: Optional[pulumi.Input[str]] = None,
            username: Optional[pulumi.Input[str]] = None) -> 'RemoteIdentity':
        """
        Get an existing RemoteIdentity resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The account for this remote identity.
        :param pulumi.Input[str] remote_identity_group_id: The remote identity group.
        :param pulumi.Input[str] username: The username to be used as the remote identity for this account.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RemoteIdentityState.__new__(_RemoteIdentityState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["remote_identity_group_id"] = remote_identity_group_id
        __props__.__dict__["username"] = username
        return RemoteIdentity(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        The account for this remote identity.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="remoteIdentityGroupId")
    def remote_identity_group_id(self) -> pulumi.Output[str]:
        """
        The remote identity group.
        """
        return pulumi.get(self, "remote_identity_group_id")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[str]:
        """
        The username to be used as the remote identity for this account.
        """
        return pulumi.get(self, "username")

